package unibo.lam.lbedogni;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class MyActivityLifeCycleActivity extends Activity {
	protected int counter = 0;

	/** Called when the activity is first created. */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Log.d("LAM2013", "ON_CREATE ");
		Toast.makeText(this, "onCreate()", Toast.LENGTH_LONG).show();
		setContentView(R.layout.main);
		
		Button killButton = (Button) findViewById(R.id.killButton);
		killButton.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				Log.d("LAM2013", "finish()");
				finish();
			}
		});
		
		Button countButton = (Button) findViewById(R.id.countButton);
		countButton.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View arg0) {
				Log.d("LAM2013", "counting");
				Toast.makeText(getApplicationContext(), "onClick()", Toast.LENGTH_LONG).show();
				counter++;
				updateCounter();
			}
		});
		updateCounter();
	}

	@Override
	protected void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		Log.d("LAM2013", "ON_SAVE_INSTANCE_STATE ");
		Toast.makeText(this, "onSaveInstanceState()", Toast.LENGTH_LONG).show();
	}

	protected void onRestoreInstanceState(Bundle savedInstanceState) {
		super.onSaveInstanceState(savedInstanceState);
		Log.d("LAM2013", "ON_RESTORE_INSTANCE_STATE ");
		Toast.makeText(this, "onRestoreInstanceState()", Toast.LENGTH_LONG).show();
		updateCounter();
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		Log.d("LAM2013", "ON_DESTROY ");
		Toast.makeText(getBaseContext(), "onDestroy()", Toast.LENGTH_LONG).show();
	}

	@Override
	protected void onPause() {
		super.onPause();
		Log.d("LAM2013", "ON_PAUSE ");
		Toast.makeText(this, "onPause()", Toast.LENGTH_LONG).show();
	}

	@Override
	protected void onRestart() {
		super.onRestart();
		Log.d("LAM2013", "ON_RESTART");
		Toast.makeText(this, "onRestart()", Toast.LENGTH_LONG).show();
	}

	@Override
	protected void onResume() {
		super.onResume();
		Log.d("LAM2013", "ON_RESUME ");
		Toast.makeText(this, "onResume()", Toast.LENGTH_LONG).show();
	}

	@Override
	protected void onStart() {
		super.onStart();
		Log.d("LAM2013", "ON_START ");
		Toast.makeText(this, "onStart()", Toast.LENGTH_LONG).show();
	}

	@Override
	protected void onStop() {
		super.onStop();
		Log.d("LAM2013", "ON_STOP ");
		Toast.makeText(this, "onStop()", Toast.LENGTH_LONG).show();
	}

	private void updateCounter() {
		TextView textView = (TextView) findViewById(R.id.counterValue);
		textView.setText("Actual counter: " + counter);
		Toast.makeText(this, "updateCounter()", Toast.LENGTH_LONG).show();
	}

}